include masm32rt.inc
include gdip.inc
include gdiplus.inc
includelib gdiplus.lib
.686p
.mmx
.xmm

WndProc 	proto :DWORD,:DWORD,:DWORD,:DWORD

WND_DATA struct
	hdc			HDC 	?
WND_DATA ends

.data?
	hInstance	dd ?
.code
main proc 
LOCAL wcex:WNDCLASSEX
LOCAL msg:MSG
LOCAL gsi:GdiplusStartupInput
LOCAL gtkn:PULONG

	mov gsi.GdiplusVersion,1
	mov gsi.DebugEventCallback,0
	mov gsi.SuppressBackgroundThread,0
	mov gsi.SuppressExternalCodecs,0
	invoke GdiplusStartup,ADDR gtkn,ADDR gsi,0

	mov hInstance,rv(GetModuleHandle,0)
	mov wcex.hInstance,eax
	mov wcex.cbSize,SIZEOF WNDCLASSEX
	mov wcex.style, CS_HREDRAW or CS_VREDRAW
	mov wcex.lpfnWndProc, OFFSET WndProc
	mov wcex.cbClsExtra,NULL
	mov wcex.cbWndExtra,SIZEOF WND_DATA
	mov wcex.hbrBackground,0
	mov wcex.lpszMenuName,NULL
	mov wcex.lpszClassName,chr$("Win32Gdi+")
	mov wcex.hIcon,rv(LoadIcon,NULL,IDI_APPLICATION)
	mov wcex.hIconSm,eax
	mov wcex.hCursor,rv(LoadCursor,NULL,IDC_ARROW)
	invoke RegisterClassEx, ADDR wcex
	mov esi,rv(CreateWindowEx,NULL,wcex.lpszClassName,"GDI+",WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,hInstance,NULL)
	invoke ShowWindow,esi,SW_SHOWNORMAL
	invoke UpdateWindow,esi

	.while 1
		invoke GetMessage,ADDR msg,NULL,0,0
		.break .if !eax || eax == -1
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.endw
	
	invoke GdiplusShutdown,gtkn
	invoke ExitProcess,msg.wParam

main endp

WndProc proc uses ebx esi edi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL ps:PAINTSTRUCT
LOCAL graphics:PVOID
LOCAL pen:PVOID


	.if uMsg == WM_CLOSE
		invoke PostQuitMessage,NULL
	.elseif uMsg == WM_DESTROY
		invoke DeleteObject,rv(GetWindowLong,hWnd,WND_DATA.hdc)
	.elseif uMsg == WM_CREATE
		mov esi,rv(GetDC,rv(GetDesktopWindow))
		mov ebx,rv(CreateCompatibleDC,esi)
		mov edi,rv(GetSystemMetrics,SM_CXSCREEN)
		invoke DeleteObject,rv(SelectObject,ebx,rv(CreateCompatibleBitmap,esi,edi,rv(GetSystemMetrics,SM_CYSCREEN)))
		invoke ReleaseDC,rv(GetDesktopWindow),esi
		invoke SetWindowLong,hWnd,WND_DATA.hdc,ebx
		
		;create graphics object 
		invoke GdipCreateFromHDC,ebx,ADDR graphics
		; clear the background
		invoke GdipGraphicsClear,graphics,-1		
		
		; not really needed - UnitPixel is the default
		invoke GdipSetPageUnit,graphics,UnitPixel
		
		; use allway UnitWorld
		invoke GdipCreatePen1,ColorsBlack,FP4(1.0),UnitWorld,ADDR pen
		
		; use the integer-version (suffix 'I')
		invoke GdipDrawEllipseI,graphics,pen,100,100,50,50
		
		; delete objects
		invoke GdipDeletePen,pen
		invoke GdipDeleteGraphics,graphics		

	.elseif uMsg == WM_PAINT
		invoke BeginPaint,hWnd,ADDR ps
		mov ebx,rv(GetWindowLong,hWnd,WND_DATA.hdc)
		mov edx,ps.rcPaint.right
		sub edx,ps.rcPaint.left
		mov ecx,ps.rcPaint.bottom
		sub ecx,ps.rcPaint.top
		invoke BitBlt,ps.hdc,ps.rcPaint.left,ps.rcPaint.top,edx,ecx,ebx,ps.rcPaint.left,ps.rcPaint.top,SRCCOPY
		invoke EndPaint,hWnd,ADDR ps	
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif

	xor eax,eax
	ret
WndProc endp

end main
